package labSolutions;

/*
 fib(i): i, for i <= 1
         fib(i-1) + fib(i-2), otherwise
 */

public class Fibonacci {
	
	/*
    naive version: use two recursive calls
    in body
	 */
	
	public static int naiveFibonacci(int i) {
		if (i <= 1) {
			return i;
		} else {
			return naiveFibonacci(i-1)+naiveFibonacci(i-2);
		}
	}
	
	/*
     constant space and linear time in Scheme:
     
     (define (iterfibonacci f1 f2 i n)
       (if (= i n)
         f2
         (iterfibonacci f2 (+ f1 f2) (+ i 1) n)))
         
	 */
	
	private static int iterFibonacciTry(int f1, int f2, int i, int n) {
	   if (i == n) {
		   return f2;
	   } else {
		   return iterFibonacciTry(f2, f1 + f2, i + 1, n);
	   }
	}
	
	/* linear space and linear time in Java */
	
	public static int iterativeFibonacciTry(int n) {
		if (n <= 1) {
			return n; 
		} else {
		  return iterFibonacciTry(1,1,2,n);
		}	
	}
	
	/*
	 real iterative behavior can only be achieved
	 with a loop in Java: 
	 constant space and linear time
	 */
	
	public static int iterativeFibonacci(int n) {
		if (n <= 1) {
			return n;
		} else {
			int f1 = 1;
			int f2 = 1;
			int i = 2;
			while (i < n) {
				int f1save = f1;
				f1 = f2; 
				f2 = f1save + f2;
				i = i + 1;
			}
		return f2;
		}	
	}
}
