package lecture;

public class IntList
{
    private int carValue;
    private IntList cdrValue;
    private boolean isEmpty;

    private IntList() {
    	isEmpty = true;
    }
    
    private IntList(int i, IntList rest) {
    	isEmpty = false;
    	carValue = i;
    	cdrValue = rest;
    }
    
    private IntList(int [] elements) {
    	if (elements.length == 0) {
    	   isEmpty = true;
    	} else {
    		isEmpty = false;
    		IntList rest = new IntList();
    		for (int i= elements.length - 1; i >= 1; i--) {
    			rest = new IntList(elements[i],rest);
    		}
    		carValue = elements[0];
    		cdrValue = rest;
       }
    }
    
    public String toString() {
    	if (isEmpty) {
    		return "[]";
    	} else {
    		return "[" + carValue + "," + cdrValue.toString() + "]";
    	} 	
    }
    
    public static IntList cons(int i, IntList list) {
    	return new IntList(i,list);
    }
    public static IntList intList(int [] elements) { return new IntList(elements); }
    public static IntList nil = new IntList();
    public static int car(IntList list){ return list.carValue; }
    public static IntList cdr(IntList list){ return list.cdrValue; }
    public static boolean isNil(IntList list) { return list.isEmpty; }
    public static void print(IntList list) { System.out.println(list); return; }
 
}
