package lecture;

public class IntListUtil {
	
	/*
	(define (length xs)
	  (if (null? xs) 
	    0
	    (+ 1 (length (cdr xs)))))
	*/
	
	public static int length(IntList aList) {
		if (IntList.isNil(aList)) {
			return 0;
		} else {
			return 1 + length(IntList.cdr(aList));
		}
	}
	
	/*
	(define (append alist anotherlist)
	  (if (null? alist)
	    anotherlist
	    (cons (car alist) (append (cdr alist) anotherlist))))
	 */
	
	public static IntList append(IntList aList, IntList anotherList) {
		if (IntList.isNil(aList)) {
			return anotherList;
		} else {
			return IntList.cons(IntList.car(aList), append(IntList.cdr(aList),anotherList));
		}
	}
	
	/*
	(define (naivereverse alist)
	  (if (null? alist)
	    '()
	    (append (naivereverse (cdr alist)) (cons (car alist) '()))))
	 */
	
	public static IntList naiveReverse(IntList aList) {
		if (IntList.isNil(aList)) {
			return IntList.nil;
		} else {
			return append(naiveReverse(IntList.cdr(aList)), 
					IntList.cons(IntList.car(aList),IntList.nil));
		}
	}
	
	/*
	(define (square alist)
	  (if (null? alist)
	    '()
	    (cons (* (car alist) (car alist)) (square (cdr alist)))))
	 */
	
	public static IntList square(IntList aList) {
		if (IntList.isNil(aList)) {
			return IntList.nil;
		} else {
			return IntList.cons(IntList.car(aList)*IntList.car(aList), square(IntList.cdr(aList)));
		}
	}
	
	/*
	(define (sum alist)
	  (if (null? alist)
	    0
	    (+ (car alist) (sum (cdr alist)))))
	 */
	
	public static int sum(IntList aList) {
		if (IntList.isNil(aList)) {
			return 0;
		} else {
			return IntList.car(aList) + sum(IntList.cdr(aList));
		}
	}
	
	/*
	(define (iterlength alist acc)
	  (if (null? alist)
	    acc
	    (iterlength (cdr alist) (+ acc 1))))
	    
	(define (iterativelength alist)
	  (iterlength alist 0))
	 */
	
	public static int iterLengthTry(IntList aList, int acc) {
		if (IntList.isNil(aList)) {
			return acc;
		} else {
			return iterLengthTry(IntList.cdr(aList), acc+1);
		}
	}
	
	public static int iterativeLengthTry(IntList aList) {
		return iterLengthTry(aList,0);
	}
	
	/*
	(let ((a 1))
      (begin
        (set! a 2)
        a))
	 */
	
	public static int iterativeLength(IntList aList) {
		int acc = 0;
		while (! IntList.isNil(aList)) {
			aList = IntList.cdr(aList);
			acc++;
		}
		return acc;
	}	
}
